// ****  sample programs for ATB-R8CQ_EX (c)AT-Laboratory  ****
// vO: LCD.C
//  쐬t   : 2005/3/10
// vO̓e:LCDW[ɕ\
// LCDW[R8CQEXCɂĕ\܂B
// ʎLCDW[ڑ}QƂĒǉzĂB
// LCDW[4^Cvɂ͑ΉĂ܂B
// 4̏ꍇɂ͏ɕύXĂB
// P3_4E[qɐڑĂ܂AZbgɃ|[gݒ肳ԁAt[eBO
// Ȃ邽߁AfobKNȂǁAhׂ\܂̏ł͂܂B
// CɂȂꍇP3_4[qOŃvAbvƉ܂B

#include "R8C15.h"

// vg^Cv錾
void DelayMs(unsigned int cnt);
void lcd_write(unsigned char c);
void lcd_clear(void);
void lcd_puts(const char * s);
void lcd_putc(char c);
void lcd_goto(unsigned char pos);
void lcd_init(void);

// LCD[qzu
#define LCD_RS		SFR_P3_5
#define LCD_E		SFR_P3_4
//#define  LCD_D4	SFR_P1_1
//#define  LCD_D5	SFR_P1_2
//#define  LCD_D6	SFR_P1_6
//#define  LCD_D7	SFR_P1_7

#define	LCD_DATA_MASK	0b00111001

#define	LCD_STROBE	((LCD_E = 1),(LCD_E=0))

// 10uS҂p}N` (nl02621܂)
#define	Delay10Us(x)	{_asm("push.w R3"); _asm("mov.w #"#x"*25,R3"); _asm("sbjnz.w #1,R3,$"); _asm("pop.w R3");}

// 1mS҂֐
void DelayMs(unsigned int cnt)
{
	unsigned int i;
	for (i=0;i<cnt;i++)
		Delay10Us(100);		// 10mS҂[vJEg 10uS*100=1mS
}

// LCD_D4-D7prbgf[^ϊe[u
static unsigned char bit_cnv[]=
{	0b00000000,0b00000010,0b00000100,0b00000110,0b01000000,0b01000010,0b01000100,0b01000110,
	0b10000000,0b10000010,0b10000100,0b10000110,0b11000000,0b11000010,0b11000100,0b11000110 };

// 4rbg[hLCDɏ
void lcd_write(unsigned char c)
{
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c >> 4)];
	LCD_STROBE;
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c & 0x0F)];
	LCD_STROBE;
	Delay10Us(4);
}

// \NA
void lcd_clear(void)
{
	LCD_RS=0;
	lcd_write(0x1);
	DelayMs(2);
}

// XgOLCD\
void lcd_puts(const char * s)
{
	LCD_RS=1;	// write characters
	while(*s)
		lcd_write(*s++);
}

// PLN^LCD\/
void lcd_putc(char c)
{
	LCD_RS=1;	// write characters
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c >> 4)];
	LCD_STROBE;
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[(c & 0x0F)];
	LCD_STROBE;
	Delay10Us(4);
}

// \ʒuw
void lcd_goto(unsigned char pos)
{
	LCD_RS=0;	// write control bytes
	lcd_write(0x80+pos);
}

// LCD
void lcd_init(void)
{
	LCD_RS=0;	// write control bytes
	DelayMs(40);	// power on delay 40mS
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[3];	// attention!
	LCD_STROBE;
	DelayMs(5);
	LCD_STROBE;
	Delay10Us(10);
	LCD_STROBE;
	DelayMs(5);
	SFR_P1=(SFR_P1 & LCD_DATA_MASK) |  bit_cnv[2];	// set 4 bit mode
	LCD_STROBE;
	Delay10Us(4);
	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0F);	// display on, blink curson on
	lcd_write(0x06);	// entry mode
}

// C[`
void main(void)
{
	SFR_P1D=~LCD_DATA_MASK;		// LCDp|[gSo
	SFR_P3D_5=1;			// LCD_RS
	SFR_P3D_4=1;			// LCD_E
	lcd_init();			// LCD

	while(1)
	{
		lcd_clear();			// ʏ
		lcd_goto(0);			// \ʒu[
		lcd_puts("LCD DEMO");
		DelayMs(1000);			// 1b҂
		lcd_goto(0);
		lcd_puts("Cݺ  ˮ");
		DelayMs(1000);
		lcd_goto(0x40);			// \ʒu[
		lcd_puts("R8C LCD Display");
		DelayMs(1000);
	}
}
