// ****  sample programs for ATB-R8CQ_EX (c)AT-Laboratory  ****
// vO: UART1.C
//  쐬t   : 2005/3/1
// vO̓e: UARTMTvvO (|[O)
//
// UART0RS232C|[gŒʐMs܂B
// p\RRS232CڑsAnCp[^[~iȂǂŒʐMƁAMf[^
// ̂܂ܑMiGR[obNj܂B	
// ʐM|[gUART0|[g(COM0RS232CRlN^)
// ʐMp[^́A19200bps/8rbgf[^/peBȂ/Xgbvrbg1
// ύX̓\[X UART_init()֐ōs܂B

#include "R8C15.h"

#define UART	0		// gpUART|[g
// UART1gpꍇɂ̓fobOł܂B

#if UART==0
#define UART_MR		SFR_U0MR
#define UART__RE	SFR_U0_RE
#define UART__TE	SFR_U0_TE
#define UART__RI	SFR_U0_RI
#define UART__TI	SFR_U0_TI

#define UART_C0		SFR_U0C0
#define UART_C1		SFR_U0C1
#define UART_BRG	SFR_U0BRG
#define UART_RB		SFR_U0RB
#define UART_TB		SFR_U0TB

#define UART_RIC	SFR_U0RIC
#define UART_TIC	SFR_U0TIC
#endif

#if UART==1
#define UART_MR		SFR_U1MR
#define UART__RE	SFR_U1_RE
#define UART__TE	SFR_U1_TE
#define UART__RI	SFR_U1_RI
#define UART__TI	SFR_U1_TI

#define UART_C0		SFR_U1C0
#define UART_C1		SFR_U1C1
#define UART_BRG	SFR_U1BRG
#define UART_RB		SFR_U1RB
#define UART_TB		SFR_U1TB

#define UART_RIC	SFR_U1RIC
#define UART_TIC	SFR_U1TIC
#endif

				// 20M		16M
#define	BRG_57600	21	//	16
#define CNTR_57600	0	//	0
#define	BRG_38400	32	//	25
#define CNTR_38400	0	//	0
#define	BRG_19200	64	//	51
#define CNTR_19200	0	//	0
#define	BRG_9600		129	//	103
#define CNTR_9600	0	//	0
#define	BRG_4800		32	//	207
#define CNTR_4800	1	//	0
#define	BRG_2400		64	//	51
#define CNTR_2400	1	//	1
#define	BRG_1200		129	//	103
#define CNTR_1200	1	//	1
#define	BRG_600		64	//	207
#define CNTR_600		2	//	1
#define	BRG_300		129	//	103
#define CNTR_300		2	//	2

#define PAR_NONE	0
#define PAR_ODD		0b01000000
#define PAR_EVEN	0b01100000

#define STOP_1		0b00000000
#define STOP_2		0b00010000

#define BIT_7		0b00000100
#define BIT_8		0b00000101
#define BIT_9		0b00000110

// vg^Cv錾
void UART_init(void);
void putc_rs(unsigned int c);
void putc_rs(unsigned int c);
unsigned int getc_rs(void);

// UART
// 19200bps 8bits parity:none stop1
void UART_init(void)
{
	UART_C0=  CNTR_19200;
	UART_BRG= BRG_19200;
	UART_MR=  PAR_NONE | STOP_1 | BIT_8;
	UART__TE=1;
	UART__RE=1;
}

// UART|[g1LN^M
void putc_rs(unsigned int c)
{
	while(UART__TI==0)
		;
	UART_TB=c;
}

// UART|[gɕ񑗐M
void puts_rs(char *str)
{
	while (*str!=0)
		putc_rs(*(str++));
}

// UART|[gPLN^M G[Ȃ
unsigned int getc_rs(void)
{
	while(UART__RI==0)
		;
	return UART_RB;			// 8rbg̓G[tO
}

// CvO
void main(void)
{
	char c;

	UART_init();

	puts_rs("\r\n<<Welcome to ATB-R8CQ_EX>>\r\n");	// ^CgM

	while(1)
	{
		c=(getc_rs() & 0xff);	// M? (G[͖)
		if (c=='\r')
			putc_rs('\n');
		putc_rs(c);				// Mꂽf[^𑗐M (Echo back)
	}
}
