//**************************************************************
//		standardI/O LCD Library Header
//			programed by TAG. 2002/06/22
//			Please modify LCD.A30 for your LCD Unit
//**************************************************************
void std_LCD_init(void);			// stdio initial for LCD
void LCD_init(void);				// LCD port initialize
void LCD_clear(void);				// LCD Screen clear
void LCD_clr_eol(void);				// clear current pos to EndOfLine
void LCD_cursor(char a);			// Cursor ON/BLINK ON
#pragma PARAMETER LCD_cursor(R1L)
void LCD_gotoX(char x);				// Display column position(X) set
#pragma PARAMETER LCD_gotoX(R1L)
void LCD_gotoY(char y);				// Display row position(Y) set
#pragma PARAMETER LCD_gotoY(R1L)
void LCD_gotoXY(char x,char y);		// Display position(XY) set
#pragma PARAMETER LCD_gotoXY(R1L,R1H)
void LCD_locate(char pos);			// Display direct position(XY) set
#pragma PARAMETER LCD_locate(R1L)
void LCD_putc(unsigned char c);		// 1 Charactor write
#pragma PARAMETER LCD_putc(R1L)
void LCD_data(unsigned char c);		// 1 Charactor direct write
#pragma PARAMETER LCD_data(R1L)
void LCD_puts(unsigned char *str);	// String write
#pragma PARAMETER LCD_puts(A0)
extern char LPOS_X;
extern char LPOS_Y;

